const LWCP_sidBroadCast=0xFFFFFFFF;
const LWCP_sidMultiCast=0xFFFF0000;
var hObj_AppControl;
var hObj_LwCH, hObj_FaCH;
var hObj_VMIX, hObj_VMIX_SUB, hObj_VMIX_SUB_IN;
var hObj_UpTimer, hObj_DnTimer;
var hObj_Intercom, hObj_IcomKey, hObj_IcomOled, hObj_IcomBtn, hObj_IcomMenu;
var hObj_Meter, hObj_MetPGM1;
/* up and down timer clients */
var lwcpUpTimerCl={};
var lwcpDnTimerCl={};
var lwcpIntercomCl={};
var lwcpPGM1Cl={};

/* Register all objects */
hObj_AppControl=host.lwcpRegisterObject(null, "AppControl", 0, 'onRecvLwMsg');
hObj_LwCH      =host.lwcpRegisterObject(null, "LwCH", 65536, 'onRecvLwCHmsg');
hObj_FaCH      =host.lwcpRegisterObject(null, "FaCH", 64, 'onRecvFaCHmsg');
hObj_VMIX      =host.lwcpRegisterObject(null, "VMIX", 0, null);
if(hObj_VMIX!=null)
{
	hObj_VMIX_SUB=host.lwcpRegisterObject(hObj_VMIX, "SUB", 8, 'lwOnRecvVMIX_SUB');
	if(hObj_VMIX_SUB!=null)
		hObj_VMIX_SUB_IN=host.lwcpRegisterObject(hObj_VMIX_SUB, "IN", 5, 'lwOnRecvVMIX_SUB_IN');
}
hObj_UpTimer=host.lwcpRegisterObject(null, "UpTimer", 0, 'lwOnRecvUpTimer');
hObj_DnTimer=host.lwcpRegisterObject(null, "DnTimer", 0, 'lwOnRecvDnTimer');

hObj_Intercom=host.lwcpRegisterObject(null, "Intercom", 0, 'lwOnIntercom');
if(hObj_Intercom!=null)
{
	hObj_IcomKey=host.lwcpRegisterObject(hObj_Intercom, "key", 10, 'lwOnIcomKey');
	hObj_IcomOled=host.lwcpRegisterObject(hObj_Intercom, "oled", 10, 'lwOnIcomOled');
	hObj_IcomBtn=host.lwcpRegisterObject(hObj_Intercom, "btn", 128+16, 'lwOnIcomBtn');
	hObj_IcomMenu=host.lwcpRegisterObject(hObj_Intercom, "menu", 0, 'lwOnIcomMenu');
}

hObj_Meter=host.lwcpRegisterObject(null, "Meter", 0, null);
if(hObj_Meter!=null)
	hObj_MetPGM1=host.lwcpRegisterObject(hObj_Meter, "PGM1", 0, 'lwOnRecvMetPGM1');

// ------------------------- * Helper Functions * -------------------------

/*
** lwcpEncodeProps
*/
function lwcpEncodeProps(props)
{
	var res="", first=true, p;

	for(p in props)
	{
		if(first)
			first=false;
		else
			res+=",";
		res+=(p+"="+props[p]);
	}
	return res;
}

function lwcpEscape(str)
{
	return str.replace(new RegExp("\\\\", "g"), "\\\\").replace(new RegExp("\"", "g"), "\\\"").replace(new RegExp("\n", "g"), "\\n").replace(new RegExp("\r", "g"), "\\r");
}

// ------------------------- * Channel Control Interface * -------------------------

// EVENT samples:
//	EVENT LwCH#1001 BTN_ON=DOWN
//
// INDI send sample:
//	sendLwCHmsg(lwch_nr, 'SET', 'LMP_ON=ON,LMP_OFF=OFF'); => SET LwCH#1001 LMP_ON=ON,LMP_OFF=OFF
//
// LW channel number(primary source number) => backtrace[0]

/*
** onRecvLwCHmsg
**
** function called when message is received for object LwCH#<id>
** id = backtrace[0] and is LW channel number (lpid)
*/
function onRecvLwCHmsg(connId, hObject, backtrace, op, props)
{
	var n, lpid=backtrace[0];
	var rmsg;

	for(n=1; n<=64; n++)
	{
		if(ch_data[n].exists && ch_data[n].lpid==lpid)
		{
			rmsg=onChnLWCPevent(n, connId, op, props);
			if(rmsg!=null) host.sendLwMsg(connId, hObject, backtrace, 'INDI', lwcpEncodeProps(rmsg));
		}
	}
}

/*
** onRecvFaCHmsg
**
** function called when message is received for object FaCH#<id>
** id = backtrace[0] and is fader channel number
*/
function onRecvFaCHmsg(connId, hObject, backtrace, op, props)
{
	var channel=backtrace[0];
	var rmsg;

	if((channel in ch_data) && ch_data[channel].exists)
	{
		rmsg=onChnLWCPevent(channel, connId, op, props);
		if(rmsg!=null) host.sendLwMsg(connId, hObject, backtrace, 'INDI', lwcpEncodeProps(rmsg));
	}
}

/*
** lwcpSendCHevent
**
** TODO: add subscription and filtering
*/
function lwcpSendCHevent(chn, props)
{
	props=lwcpEncodeProps(props);
/* first we send FaCH event */
	host.sendLwMsg(LWCP_sidBroadCast, hObj_FaCH, [chn.id], 'EVENT', props);
/* next if lpid is defined send LwCH event */
	if(chn.lpid!=0) host.sendLwMsg(LWCP_sidBroadCast, hObj_LwCH, [chn.lpid], 'EVENT', props);
}

/*
** sendLwCHmsg
**
** sends LwCH multicast message
*/
function sendLwCHmsg(ch, op, props)
{
	host.sendLwMsg(LWCP_sidMultiCast, hObj_LwCH, [ch], op, props);
}

/*
 Timer Operations (UpTimer example)
 
A - advantech PC
E - Element

1st Case: paralel control (both E and A can control timer)

A: SUB UpTimer
E: ACK UpTimer OP=SUB,Status=OK
A: GET UpTimer Value,State,Freeze
E: INDI UpTimer Value=0,State=OFF,Freeze=OFF
# A: set timer to received values
# E: on value changes (local Element control, or other remote)
E: EVENT UpTimer Value=0,State=ON,Freeze=OFF
# A: set timer to received values
# A: local control: Start
A: SET UpTimer State=ON
E: EVENT UpTimer Value=0,State=ON,Freeze=OFF
# A: set timer to received values
# A: local control: Stop
A: SET UpTimer State=OFF
E: EVENT UpTimer Value=0,State=OFF,Freeze=OFF
# A: set timer to received values
# A: local control: Reset
A: SET UpTimer Value=0
E: EVENT UpTimer Value=0,State=ON,Freeze=OFF
# A: set timer to received values
# A: local control: Freeze
A: SET UpTimer Freeze=ON
E: EVENT UpTimer Value=0.5,State=OFF,Freeze=0
# A: set timer to received values
# A: local control: UnFreeze
A: SET UpTimer Freeze=OFF
E: EVENT UpTimer Value=0.5,State=OFF,Freeze=OFF
# A: set timer to received values

*/

function lwOnRecvUpTimer(connId, hObject, backtrace, op, props)
{
	var p, rmsg={};

	if(connId==LWCP_sidMultiCast) return;
	if(op=="SUB")
	{
		lwcpUpTimerCl[connId]=true;
		rmsg.OP=op;
		rmsg.Status='OK';
		host.sendLwMsg(connId, hObject, backtrace, "ACK", lwcpEncodeProps(rmsg));
		return;
	}
	if(op=="UNSUB")
	{
		if(connId in lwcpUpTimerCl)
		{
			delete lwcpUpTimerCl[connId];
			rmsg.OP=op;
			rmsg.Status='OK';
			host.sendLwMsg(connId, hObject, backtrace, "ACK", lwcpEncodeProps(rmsg));
		}
		return;
	}
	if(op=="SET")
	{
		if(!(connId in lwcpUpTimerCl)) return;
		if(('Value' in props) && typeof(props.Value)=="number") upTimerObj.setMs(Math.floor(props.Value*1000));
		if('Freeze' in props)
			switch(props.Freeze)
		{
		case 'ON':
			upTimerObj.freeze();
			break;
		case 'OFF':
			upTimerObj.unfreeze();
			break;
		}
		if('State' in props)
			switch(props.State)
		{
		case 'ON':
			upTimerObj.start();
			break;
		case 'OFF':
			upTimerObj.stop();
			break;
		}
		return;
	}
	if(op=="GET")
	{
		for(p in props)
			switch(p)
		{
		case 'Value' : rmsg[p]=upTimerObj.getValue(); break;
		case 'State' : rmsg[p]=upTimerObj.getState()?"ON":"OFF"; break;
		case 'Freeze': rmsg[p]=upTimerObj.getFreeze(); break;
		case 'Mode'  : rmsg[p]=timer_mode; break;
		}
		host.sendLwMsg(connId, hObject, backtrace, "INDI", lwcpEncodeProps(rmsg));
	}
}

function lwOnRecvDnTimer(connId, hObject, backtrace, op, props)
{
	var p, rmsg={};

	if(connId==LWCP_sidMultiCast) return;
	if(op=="SUB")
	{
		lwcpDnTimerCl[connId]=true;
		rmsg.OP=op;
		rmsg.Status='OK';
		host.sendLwMsg(connId, hObject, backtrace, "ACK", lwcpEncodeProps(rmsg));
		return;
	}
	if(op=="UNSUB")
	{
		if(connId in lwcpDnTimerCl)
		{
			delete lwcpDnTimerCl[connId];
			rmsg.OP=op;
			rmsg.Status='OK';
			host.sendLwMsg(connId, hObject, backtrace, "ACK", lwcpEncodeProps(rmsg));
		}
		return;
	}
	if(op=="SET")
	{
		if(!(connId in lwcpDnTimerCl)) return;
		if(('Value' in props) && typeof(props.Value)=="number") dnTimerObj.setMs(Math.floor(props.Value*1000));
		if('Freeze' in props)
			switch(props.Freeze)
		{
		case 'ON':
			dnTimerObj.freeze();
			break;
		case 'OFF':
			dnTimerObj.unfreeze();
			break;
		}
		if('State' in props)
			switch(props.State)
		{
		case 'ON':
			dnTimerObj.start();
			break;
		case 'OFF':
			dnTimerObj.stop();
			break;
		}
		return;
	}
	if(op=="GET")
	{
		for(p in props)
			switch(p)
		{
		case 'Value'  : rmsg[p]=dnTimerObj.getValue(); break;
		case 'State'  : rmsg[p]=dnTimerObj.getState()?"ON":"OFF"; break;
		case 'Freeze' : rmsg[p]=dnTimerObj.getFreeze(); break;
		case 'FromVal': rmsg[p]=cfg_countdownfrom; break;
		}
		host.sendLwMsg(connId, hObject, backtrace, "INDI", lwcpEncodeProps(rmsg));
	}
}

function lwSendTimerEvent(uptimer, msg)
{
	var props;
	var p;

	props=lwcpEncodeProps(msg);
	if(uptimer)
	{
		for(p in lwcpUpTimerCl)
			host.sendLwMsg(p, hObj_UpTimer, [0], "EVENT", props);
	}
	else
	{
		for(p in lwcpDnTimerCl)
			host.sendLwMsg(p, hObj_DnTimer, [0], "EVENT", props);
	}
}

// ------------------------- * Intercom * -------------------------

function lwSendIntercomEvent(msg, obj, backtrace)
{
	var props;
	var p;

	props=lwcpEncodeProps(msg);
	for(p in lwcpIntercomCl)
		host.sendLwMsg(p, obj, backtrace, "EVENT", props);
}

function lwOnIntercom(connId, hObject, backtrace, op, props)
{
	var rmsg={}, p;

	if(op=="SUB")
	{
		log.info_f("LWCP connection %d SUB'ed to Intercom", connId);
		lwcpIntercomCl[connId]=true;
		rmsg.OP=op;
		rmsg.Status='OK';
		host.sendLwMsg(connId, hObject, backtrace, "ACK", lwcpEncodeProps(rmsg));
		return;
	}
	if(op=="UNSUB")
	{
		if(connId in lwcpIntercomCl)
		{
			log.info_f("LWCP connection %d UNSUB'ed from Intercom", connId);
			delete lwcpIntercomCl[connId];
			rmsg.OP=op;
			rmsg.Status='OK';
			host.sendLwMsg(connId, hObject, backtrace, "ACK", lwcpEncodeProps(rmsg));
		}
		return;
	}
	if(op=="GET")
	{
		for(p in props)
			switch(p)
		{
		case 'type': rmsg[p]=mod.getIcomType(); break;
		}
		host.sendLwMsg(connId, hObject, backtrace, "INDI", lwcpEncodeProps(rmsg));
	}
	if(op=="SET")
	{
		if(!(connId in lwcpIntercomCl)) return;
		if('listen' in props) host.sendNestCmsg('mPREV', {id:'WRIN', bEXON:((props.listen=='ON')?1:0)});
		if('talk' in props) host.sendNestCmsg('mTALK', {id:'WRIN', bEXTR:((props.talk=='ON')?1:0)});
		return;
	}
}

function lwOnIcomOled(connId, hObject, backtrace, op, props)
{
	if(op=="SET")
	{
		if(!(connId in lwcpIntercomCl)) return;
		if('line1' in props) mod.setIcomOled(backtrace[1]-1, 0, props.line1);
		if('line2' in props) mod.setIcomOled(backtrace[1]-1, 1, props.line2);
		return;
	}
}

var icomMenuCursor=0;
var icomMenuList=[];

function icomUpdateMenu()
{
	var cursor=0, offset=0;
	var list=[];
	var n;

	if(icomMenuCursor<=0 || icomMenuCursor>icomMenuList.length)
	{
		offset=0;
		cursor=0;
	}
	else if(icomMenuCursor<=2 || icomMenuList.length<=4)
	{
		offset=0;
		cursor=icomMenuCursor;
	}
	else if(icomMenuCursor==icomMenuList.length)
	{
		offset=icomMenuList.length-4;
		cursor=4;
	}
	else
	{
		offset=icomMenuCursor-3;
		cursor=3;
	}

/* fill list */
	for(n=0; n<4; n++)
		list[n]=((n+offset) in icomMenuList)?icomMenuList[n+offset]:"";
	mod.setIcomMenu(cursor, list[0], list[1], list[2], list[3]);
}

function lwOnIcomMenu(connId, hObject, backtrace, op, props)
{
	var rmsg={}, p;

	if(op=="GET")
	{
		for(p in props)
			switch(p)
		{
		case 'selected': rmsg[p]=icomMenuCursor; break;
		}
		host.sendLwMsg(connId, hObject, backtrace, "INDI", lwcpEncodeProps(rmsg));
	}
	else if(op=="SET")
	{
		if(!(connId in lwcpIntercomCl)) return;
		if('selected' in props) icomMenuCursor=parseInt(props.selected);
		if('list' in props)
		{
			if(typeof(props.list)=='object' && props.list!==null && ('length' in props.list))
				icomMenuList=props.list;
			else
				icomMenuList=[];
		}
		icomUpdateMenu();
	}
}

const lwcp_indStyles=
{
	"OFF": 0,
	"FLASH_ULTRA": 1,
	"FLASH_FAST": 2,
	"FLASH_MEDIUM": 4,
	"FLASH_SLOW": 8,
	"WINK": 6,
	"ON": 255,

	"FLASH": 4,
	"FLASH_1000": 8,
	"FLASH_500": 4,
	"FLASH_250": 2,
	"FLASH_125": 1,
	"FLASH_375_125": 3,
	"DBL_WINK_125": 5
};
const lwcp_indColors=
{
	"OFF": 0,
	"BLACK": 0,
	"RED": 1,
	"GREEN": 2,
	"YELLOW": 3,
	"ON": 3
};
const lwcp_ledColors=
{
	"OFF": 0,
	"BLACK": 0,
	"RED": 0x0F,
	"GREEN": 0xF0,
	"YELLOW": 0xFF,
	"ON": 255
};
function lwcpDecodeNumber(val, table, def, min, max)
{
	if(typeof(val)=="number") return clamp(val, min, max);
	if(val in table) return table[val];
	return def;
}

function lwOnIcomBtn(connId, hObject, backtrace, op, props)
{
	var rmsg={}, p;

	if(op=="GET")
	{
		for(p in props)
			switch(p)
		{
		case 'KEY': rmsg[p]=mod.getIcomBtn(backtrace[1]-1)?'DOWN':'UP'; break;
		}
		host.sendLwMsg(connId, hObject, backtrace, "INDI", lwcpEncodeProps(rmsg));
	}
	else if(op=="SET")
	{
		if(!(connId in lwcpIntercomCl)) return;
		if('IND' in props) mod.setIcomLed(backtrace[1]-1, lwcpDecodeNumber(props.IND, lwcp_indStyles, 0, 0, 255));
	}
}

var icomKey=[0xC0,0xC0,0xC0,0xC0,0xC0,0xC0,0xC0,0xC0,0xC0,0xC0]; /* 10 default key styles - ON color yellow, OFF color black, pattern OFF */
function lwOnIcomKey(connId, hObject, backtrace, op, props)
{
	var rmsg={}, p, idx=(backtrace[1]-1);

	if(op=="GET")
	{
		for(p in props)
			switch(p)
		{
		case 'KEY': rmsg[p]=mod.getIcomKey(idx)?'DOWN':'UP'; break;
		}
		host.sendLwMsg(connId, hObject, backtrace, "INDI", lwcpEncodeProps(rmsg));
	}
	else if(op=="SET")
	{
		var style=icomKey[idx], upd=false, v;

		if(!(connId in lwcpIntercomCl)) return;
		if('IND' in props)
		{
			v=lwcpDecodeNumber(props.IND, lwcp_indStyles, 0, 0, 15);
			style=(style&0xF0)|(v&0x0F);
			upd=true;
		}
		if('BACKCOLORON' in props)
		{
			v=lwcpDecodeNumber(props.BACKCOLORON, lwcp_indColors, 3, 0, 3);
			style=(style&0x3F)|((v&3)<<6);
			upd=true;
		}
		if('BACKCOLOROFF' in props)
		{
			v=lwcpDecodeNumber(props.BACKCOLOROFF, lwcp_indColors, 0, 0, 3);
			style=(style&0xCF)|((v&3)<<4);
			upd=true;
		}
		if(upd) mod.setIcomKeyLed(idx, icomKey[idx]=style);
	}
}

function onIcomEvent(type)
{
	lwSendIntercomEvent({type: type}, hObj_Intercom, [0]);
}
function onIcomKeyDown(key)
{
	lwSendIntercomEvent({KEY: 'DOWN'}, hObj_IcomKey, [0, key+1]);
}
function onIcomKeyUp(key)
{
	lwSendIntercomEvent({KEY: 'UP'}, hObj_IcomKey, [0, key+1]);
}
function onIcomBtnDown(btn)
{
	lwSendIntercomEvent({KEY: 'DOWN'}, hObj_IcomBtn, [0, btn+1]);
}
function onIcomBtnUp(btn)
{
	lwSendIntercomEvent({KEY: 'UP'}, hObj_IcomBtn, [0, btn+1]);
}
function onIcomRotaryEvent(index, delta, value)
{
	lwSendIntercomEvent({rot: delta}, hObj_IcomBtn, [0, index+128+1]);
}

function lwOnRecvMetPGM1(connId, hObject, backtrace, op, props)
{
	var rmsg={};

	if(op=="SUB")
	{
		gui.hookMeter(mtrGUI.pgm1, true);
		lwcpPGM1Cl[connId]=true;
		rmsg.OP=op;
		rmsg.Status='OK';
		host.sendLwMsg(connId, hObject, backtrace, "ACK", lwcpEncodeProps(rmsg));
		return;
	}
	if(op=="UNSUB")
	{
		if(connId in lwcpPGM1Cl)
		{
			gui.hookMeter(mtrGUI.pgm1, false);
			delete lwcpPGM1Cl[connId];
			rmsg.OP=op;
			rmsg.Status='OK';
			host.sendLwMsg(connId, hObject, backtrace, "ACK", lwcpEncodeProps(rmsg));
		}
		return;
	}
}

function onLWconnClosed(connId)
{
	if(connId in lwcpUpTimerCl) delete lwcpUpTimerCl[connId];
	if(connId in lwcpDnTimerCl) delete lwcpDnTimerCl[connId];
	if(connId in lwcpIntercomCl) delete lwcpIntercomCl[connId];
	if(connId in lwcpPGM1Cl) {gui.hookMeter(mtrGUI.pgm1,false);delete lwcpPGM1Cl[connId];}
}

/*
** onRecvLwMsg
**
** this function got called when element receives LWCP message to object AppControl
**
** parameters:
** sid:       connection identifier, used to send reply message
** hObj:      handle to LWCP object, used to send reply message
** backtrace: object indices for current and parent object OBJ#1.SUB#2 will give backtrace [1,2]
** op:        operation ('EVENT', 'INDI', etc..)
** props:     message properties array of objects: {id: <property id>, val: <property value>}
**
** to send LWCP message:
** host.sednLwMsg(sid, hObj, backtrace, op, props);
** example:
**   host.sendLwMsg(sid, object_AppControl, [0], "EVENT", "COLOR=RED,ID=100");
**  will send LWCP message:
**   EVENT AppControl COLOR=RED,ID=100
*/
function onRecvLwMsg(connId, hObject, backtrace, op, props)
{
	var p, rmsg={};

	for(p in props)
	{
	// on GET operation gather all needed prop values
		if(op=="GET")
			rmsg[p]=lwGetProp(p);
		else if(op=="SET")
			lwSetProp(p, props[p]);
	}

	if(op=="GET")
		host.sendLwMsg(connId, hObject, backtrace, "INDI", lwcpEncodeProps(rmsg));
}

// GET AppControl ShowProfID,ShowProfName,ShowProfStat
// INDI AppControl ShowProfID=1,ShowProfName="Default",ShowProfStat=READY
//
// GET AppControl ShowProfList
// INDI AppControl ShowProfList=%BeginEncap%
// <List>
// 	<ShowProfile><ID>1</ID><Name>Default</Name></ShowProfile>
// </List>
// %EndEncap%
function lwGetProp(prop)
{
	switch(prop)
	{
	case "ShowProfID":   return cur_show_id;
	case "ShowProfName": return '"'+cur_show_name+'"';
	case "ShowProfStat": return (cur_show_loading?"LOADING":"READY");
	case "ShowProfList": return lwGetShowProfList();
	case "FaderList":
	{
		var n, s="";
		for(n=1; n<=64; n++)
			if(ch_data[n].exists)
				s+=(s==""?"":",")+n;
		return "["+s+"]";
	}
	case "DateMS":
	{
		var d=new Date();
		return d.getTime()-d.getTimezoneOffset()*60*1000;
	}
	case "Date": return '"'+(new Date()).toLocaleString()+'"';
	}
	return 'undefined';
}

function lwEscapeXMLname(str)
{
	return str.replace(new RegExp("&", "g"), "&amp;").replace(new RegExp("<", "g"), "&lt;").replace(new RegExp(">", "g"), "&gt;");
}

function lwGetShowProfList()
{
	var list="", msg;
	var n, tag, show;

	msg=host.sendCmsgRq({id:"READ", bSHLE:0});
	if(msg!=null && ('mSHLE' in msg) && ('wSHLC' in msg))
	{
		for(n=1; n<=msg.wSHLC; n++)
		{
			tag=host.sprintf("m%04d", n);
			if(!(tag in msg.mSHLE)) continue;
			show=msg.mSHLE[tag];
			if(!('dSHWI' in show) || !('sSHWN' in show)) continue;
			list+="\t<showprofile><id>"+show.dSHWI+"</id><name>"+lwEscapeXMLname(show.sSHWN)+"</name></showprofile>\r\n";
		}
	}
	return "%BeginEncap%\r\n<list>\r\n"+list+"</list>\r\n%EndEncap%";
}

function lwGetSrcProfList(channel)
{
	var list="", rmsg;
	var n, tag, src;

	rmsg=getSourceList(channel, true);
	if(rmsg!=null && ('wSRLC' in rmsg) && ('mSRLE' in rmsg))
	{
		for(n=1; n<=rmsg.wSRLC; n++)
		{
			tag=host.sprintf("m%04d", n);
			if(!(tag in rmsg.mSRLE)) continue;
			src=rmsg.mSRLE[tag];
			if(!('dSRCI' in src) || !('dPSID' in src) || !('sSRCN' in src)) continue;
			list+="\t<src><id>"+src.dSRCI+"</id><lwch>"+src.dPSID+"</lwch><name>"+lwEscapeXMLname(src.sSRCN)+"</name></src>\r\n";
		}
	}
	return "%BeginEncap%\r\n<list>\r\n"+list+"</list>\r\n%EndEncap%";
}

// SET AppControl ShowProfID=7
// EVENT AppControl ShowProfID=7,ShowProfName="new1",ShowProfStat=LOADING
// EVENT AppControl ShowProfID=7,ShowProfName="new1",ShowProfStat=READY
function lwSetProp(prop, val)
{
	if(prop=="ShowProfID")
		host.sendNestCmsg('mSHOW', {id:"WRIN", dSHWI:val});
}

// EVENT AppControl ShowProfID=7,ShowProfName="new1",ShowProfStat=LOADING
// EVENT AppControl ShowProfID=7,ShowProfName="new1",ShowProfStat=READY
function lwEventProfChange()
{
	var pnames=["ShowProfID", "ShowProfName", "ShowProfStat"];
	var rmsg={};
	var n;

	for(n=0; n<pnames.length; n++)
		rmsg[pnames[n]]=lwGetProp(pnames[n]);

	host.sendLwMsg(LWCP_sidBroadCast, hObj_AppControl, [0], "EVENT", lwcpEncodeProps(rmsg));
}

function lwEventTimeChange()
{
	var d=new Date();
	var ms=d.getTime()-d.getTimezoneOffset()*60*1000

	host.sendLwMsg(LWCP_sidBroadCast, hObj_AppControl, [0], "EVENT", "DateMS="+ms);
}

// TODO: this is a simple test example of what onRecvLwCHmsg function may look like
// this function is being called each time a multicast LWCP message is being received by element
// moreover it will react to LwCH#xxx objects only, where xxx is being placed in backtrace[0] as an unsigned integer
// and describes Livewire channel number (i.e. primary source number)
// it is possible to send a message as a reply or just standalone
// message will be delivered to anyone who cares, by the means of multicast
// this is done by host.sednLwMsg(0xFFFF0000, hObj, backtrace, op, props);

// FIXME:  move const and Ind.HP functions somewhere else, maybe
const acc_list=
[
	{text:"MONITOR 2", tag:"MON2"},
	{text:"PROGRAM 1", tag:"PGM1", lock: "stmo_pgm"},
	{text:"PROGRAM 2", tag:"PGM2", lock: "stmo_pgm"},
	{text:"PROGRAM 3", tag:"PGM3", lock: "stmo_pgm"},
	{text:"PROGRAM 4", tag:"PGM4", lock: "stmo_pgm"},
	{text:"RECORD", tag:"REC1", lock: "stmo_pgm"},
	{text:"PHONE", tag:"PHO1", lock: "stmo_pgm"},
	{text:"AUXSEND A", tag:"AUX1", lock: "stmo_aux"},
	{text:"AUXSEND B", tag:"AUX2", lock: "stmo_aux"},
	{text:"AUXSEND C", tag:"AUX3", lock: "stmo_aux"},
	{text:"AUXSEND D", tag:"AUX4", lock: "stmo_aux"}
];
var hp_src_list = [];
var hp_src_version = -1;

function acc_list_text(tag)
{
	var len = hp_src_list.length, i;
	for(i=0; i<len; i++)
		if (hp_src_list[i].tag == tag)
			return hp_src_list[i].text;
	return "";
}
// returns new tag
function acc_scroll_tag(cur_tag, delta)
{
// find
	var len = hp_src_list.length, i, pos=0;
	for(i=0; i<len; i++)
		if (hp_src_list[i].tag == cur_tag){
			pos = i;
			break;
		}
	var newpos = inLimit(pos+delta, 0, len-1);
	return hp_src_list[newpos].tag;
}

function acc_mod_on(x)
{
	var string_tag = x.presetMode == 0 ? "*" : ">";

	if ((x.presetMode==0 && x.hptg_scroll == x.hptg) // selecting main source
	|| (x.presetMode==1 && x.hptg_scroll == x.hp_pset1) // selecting Preset 1 source
	|| (x.presetMode==2 && x.hptg_scroll == x.hp_pset2) // selecting Preset 2 source
	)
		sendLwCHmsg(x.lpid, 'SET', 'DSP_HPtext="'+string_tag+x.hp_src_name+'"');
	else
		sendLwCHmsg(x.lpid, 'SET', 'DSP_HPtext="'+acc_list_text(x.hptg_scroll)+'"');
	if (x.presetMode>0)
		sendLwCHmsg(x.lpid, 'SET', 'LMP_HPpset'+x.presetMode+'=ON');
}

function acc_mod_off(x)
{
	sendLwCHmsg(x.lpid, 'SET', 'DSP_HPtext=""')
	if (x.presetMode>0)
		sendLwCHmsg(x.lpid, 'SET', 'LMP_HPpset'+x.presetMode+'=OFF');
}

function switch_off_acc_module(c_ch)
{
	c_ch.srcresetTimeout=host.clearTimeout(c_ch.srcresetTimeout);
	c_ch.gainconfirmTimeout=host.clearTimeout(c_ch.gainconfirmTimeout);
	c_ch.presetTimeout=host.clearTimeout(c_ch.presetTimeout);

	c_ch.hp_scroll_mode = 0;
	c_ch.presetMode = 0;
	object_blinker_acc_mod.remove(c_ch);
	if(c_ch.lpid!=0)
		sendLwCHmsg(c_ch.lpid, 'SET', 'LMP_ON=OFF, LMP_OFF=OFF, LMP_TALK=OFF, LMP_MUTE=OFF, LMP_HPpset1=OFF, LMP_HPpset2=OFF, DSP_HPtext=""');
}

function selectPreset(i, preset)
{
	var chn=ch_data[i];

	if(chn.hp_scroll_mode == 2 && chn.presetMode == preset)
	{
		object_blinker_acc_mod.remove(chn);
	// accept new preset
		if(preset==1)
			chn.hp_pset1 = chn.hptg_scroll;
		else
			chn.hp_pset2 = chn.hptg_scroll;
		chn.presetMode = 0;
		chn.hp_scroll_mode = 0;
		chn.hptg = chn.hptg_scroll
		if(preset==1)
			sendLwCHmsg(chn.lpid, 'SET', 'LMP_HPpset1='+(chn.hp_pset1==chn.hptg?"ON":"OFF"));
		else
			sendLwCHmsg(chn.lpid, 'SET', 'LMP_HPpset2='+(chn.hp_pset2==chn.hptg?"ON":"OFF"));

	// accept new Main source
		host.sendChnCmsg(i, {id:"WRIN",
			bvHPTG:strToArr(chn.hptg),
			mHPP1:{id:"NEST", bvHPTG:strToArr(chn.hp_pset1)},
			mHPP2:{id:"NEST", bvHPTG:strToArr(chn.hp_pset2)}
		});

		chn.srcresetTimeout=host.clearTimeout(chn.srcresetTimeout);
	}
	else if(chn.presetMode==0)
	{
	// switch to preset src selection
		chn.presetMode = preset;
		chn.presetTimeout = host.setTimeout(3000, enablePresetSelection, chn);
	}
}

function enablePresetSelection()
{
	var chn=ch_data[this.id];

	if(chn.presetMode==0) return;

	chn.hp_scroll_mode = 2;
	load_src_list();
// enable source selection mode and display current source
	chn.hptg_scroll=chn.presetMode==1?chn.hp_pset1:chn.hp_pset2;
	sendLwCHmsg(this.lpid, 'SET', 'DSP_HPtext=">'+acc_list_text(chn.hptg_scroll)+'"');

	object_blinker_acc_mod.add(chn, function(x) { return x.hp_scroll_mode==2?true:false; }, true, acc_mod_on, acc_mod_off)
	chn.srcresetTimeout=host.resetTimeout(chn.srcresetTimeout, 15000, srcreset, chn);
}

// create list of all sources (Monitor2 follow and Internal and External together)
function load_src_list()
{
	var rmsg;
	var n, tag, src;

	rmsg = host.sendCmsgRq({id:"READ", bSRLV:0, bCHNR:src_list_mask.mon2});
	if(rmsg!=null && ('dSRLV' in rmsg))
	{
		if(rmsg.dSRLV==hp_src_version)
			return;
		else
			hp_src_version = rmsg.dSRLV;
	}

	hp_src_list=[];
	for(n=0; n<acc_list.length; n++)
	{
		if(('lock' in acc_list[n]) && (acc_list[n].lock in mstEnable) && !mstEnable[acc_list[n].lock])
			continue;
		hp_src_list.push({text:acc_list[n].text, tag:acc_list[n].tag});
	}

	if(mstEnable.stmo_ext)
	{
		rmsg=getSourceList(src_list_mask.mon2, true);
		if(rmsg!=null && ('mSRLE' in rmsg))
		{
			for(n=1; n<=rmsg.wSRLC; n++)
			{
				tag=host.sprintf("m%04d", n);
				if(!(tag in rmsg.mSRLE)) continue;

				src=rmsg.mSRLE[tag];
				if(!('bvSTAG' in src) || !('sSRCN' in src)) continue;

				hp_src_list.push({text:src.sSRCN, tag:host.arrtostr(src.bvSTAG)});
			}
		}
	}
}

function indicateHPGain(id, lwch_nr)
{
	var volume_indicator = '', j, c;
	var gain = mon_vol_idx_to_db[ch_data[id].hp_gain];

	c = 0;
	for (j=1; j <= ch_data[id].hp_gain; j = j+17)
	{
		c++;
		if(c==5)
		{
			volume_indicator += String.fromCharCode(27); // 5
			c = 0;
		}
	}
	if(c>0)
		volume_indicator += String.fromCharCode(32-c); // 4
	sendLwCHmsg(lwch_nr, 'SET', 'DSP_HPtext="'+volume_indicator+'"');
}

function restoreSrcName()
{
	this.gainconfirmTimeout=null;
	sendLwCHmsg(this.lpid, 'SET', 'DSP_HPtext="'+this.hp_src_name+'"');
}

function confirmHPGain()
{
	this.gainconfirmTimeout=null;
/* confirm gain value to ACL */
	host.sendChnCmsg(this.id, {id:'WRIN', wHPGN:mon_vol_idx_to_db[this.hp_gain]});
/* set timeout for gain to disappear */
	this.gainconfirmTimeout=host.setTimeout(2000, restoreSrcName, this);
}

function srcreset()
{
	var chn=ch_data[this.id];

// cancel source selection mode and go back to current source indication
	object_blinker_acc_mod.remove(chn);
	sendLwCHmsg(this.lpid, 'SET', 'DSP_HPtext="'+this.hp_src_name+'"');
	if(chn.presetMode==1)
		sendLwCHmsg(this.lpid, 'SET', 'LMP_HPpset1='+(chn.hp_pset1==chn.hptg?"ON":"OFF"));
	else
		sendLwCHmsg(this.lpid, 'SET', 'LMP_HPpset2='+(chn.hp_pset2==chn.hptg?"ON":"OFF"));
	chn.hp_scroll_mode = 0;
	chn.srcresetTimeout = null;
	chn.presetMode = 0;
}

/*
** lwOnRecvVMIX_SUB_IN
*/
function lwOnRecvVMIX_SUB_IN(sid, hObj, backtrace, op, props)
{
	var p, rmsg={};
	var i=backtrace[1], j=backtrace[2];
	var vmixIN;

	for(p in props)
	{
		if(op=="GET")
		{
			vmixIN=vmixer["VM0"+i]["IN0"+j];
			switch(p)
			{
			case 'TimeUp'  : rmsg[p]=vmixIN.TMUP; break;
			case 'TimeDown': rmsg[p]=vmixIN.TMDN; break;
			case 'Gain'    : rmsg[p]=vmixIN.FAGN; break;
			case 'State'   : rmsg[p]=(vmixIN.RAMP==0?'OFF':'ON'); break;
			}
		}
		else if(op=="SET")
		{
			switch(p)
			{
			case 'State'   : lwVmixer_set_prop(i, j, 'bRAMP', (props[p]=='ON')?1:0); break;
			case 'TimeUp'  : lwVmixer_set_prop(i, j, 'wTMUP', clamp(props[p], 0, 600)); break;
			case 'TimeDown': lwVmixer_set_prop(i, j, 'wTMDN', clamp(props[p], 0, 600)); break;
			case 'Gain'    : lwVmixer_set_prop(i, j, 'wFAGN', clamp(props[p], -800, 100)); break;
			}
		}
	}

	if(op=="GET")
		host.sendLwMsg(sid, hObj, backtrace, "INDI", lwcpEncodeProps(rmsg));
}

/*
** lwOnRecvVMIX_SUB
*/
function lwOnRecvVMIX_SUB(sid, hObj, backtrace, op, props)
{
	var p, rmsg={};
	var i=backtrace[1];
	var vmixVM;

	if(i==0) return;

	for(p in props)
	{
	// on GET operation gather all needed prop values
		if(op=="GET")
		{
			vmixVM=vmixer["VM0"+i];
			switch(p)
			{
			case 'Master_Gain':
				rmsg[p]=vmixVM.MSGN;
				break;
			}
		}
		else if(op=="SET")
		{
			switch(p)
			{
			case 'Master_Gain':
				lwVmixer_set_prop(i, 0, 'wMSGN', clamp(props[p], -800, 100));
				break;
			}
		}
	}

	if(op=="GET")
		host.sendLwMsg(sid, hObj, backtrace, "INDI", lwcpEncodeProps(rmsg));
}

function lwVmixer_set_prop(sub, inpt, tag, value)
{
	var vm_msg = {id:"NEST"};
	var mixer_msg = {id:"NEST"};
	var fader_msg;

	if (inpt>0)
	{
		fader_msg = {id:"WRIN"};
		fader_msg[tag] = value;
		mixer_msg["mIN0"+inpt] = fader_msg;
	}
	if (tag == "wMSGN")
		mixer_msg["wMSGN"] = value;

	vm_msg["mVM0"+sub] = mixer_msg;

	host.sendNestCmsg('mVMIX', vm_msg);
}

function ch_pgmx_event(chn, pgm)
{
	var props={};
	props["Asg_PGM"+pgm]=chn.pgm[pgm]?"ON":"OFF";
	lwcpSendCHevent(chn, props);
}

// ------------------------- * Meter Hooking * -------------------------

function onMeterHook(id, peak, l, r)
{
	var p, props;

	if(id!=881) return;
	props=(peak?"PPM=[":"VU=[")+l+","+r+"]";
	for(p in lwcpPGM1Cl)
		host.sendLwMsg(p, hObj_MetPGM1, [0], "EVENT", props);
}
