// ------------------------ channel option page ------------------------
const propOn={color:gui.rgb(255, 26, 0)}, propOff={color:gui.rgb(129, 169, 191)}, propAct={color:gui.rgb(254, 222, 88)};

function choptCreateSource(frm)
{
	var obj={id:'chsrc'};
	obj.frame=gui.newFrame(frm, 67, 80, 152, 77, "img/chopt_source.png");
	obj.name =gui.newLabel(obj.frame, 10, 29, 110, 19, '', prop_src);
	obj.type =gui.newLabel(obj.frame, 39, 15,  76, 14, '', prop_value_left);
	obj.stat =gui.newLabel(obj.frame, 13, 48, 133, 14, '', prop_value_left);
	obj.owner=gui.newLabel(obj.frame, 13, 61, 133, 14, '', prop_value_left);
	GUI_createSmallMeter(obj.frame, 122, 23, mtrGUI.chopt_src);

	obj.src_state=sstat.error;
	obj.src_owner="";
	obj.src_fader=0;

	obj.focus=function(on)
	{
		var bg=on?"img/chopt_source_sel.png":"img/chopt_source.png";
		var prop=on?propOn:propOff;

		this.frame.setBg(bg);
		this.type.setProps(prop);
		this.stat.setProps(prop);
		this.owner.setProps(prop);
	}
	obj.indi=function(msg)
	{
		var update=false;

		if('bvSRCN' in msg) this.name.setText(host.arrtostr(msg.bvSRCN));
		if( 'bSRCT' in msg)
		{
			if(msg.bSRCT==srct.idle)
			{
				this.stat.hide();
				this.owner.hide();
			}
			else
			{
				this.stat.show();
				this.owner.show();
			}
			this.type.setText((msg.bSRCT in srct_txt)?srct_txt[msg.bSRCT]:"");
		}

		if('sSCON' in msg) {this.src_owner=msg.sSCON; update=true;}
		if('bSCFN' in msg) {this.src_fader=msg.bSCFN; update=true;}
		if(update) this.updateSharingInfo();
	}
	obj.updateSharingInfo=function()
	{
		var status=null, owner="";
		switch(this.src_state)
		{
		case sstat.listenonly:
			status="LISTEN ONLY";
			owner=this.src_owner;
			if(this.src_fader>0) owner=(this.src_fader+": ")+owner;
			break;
		case sstat.full_control:
			status="FULL CONTROL";
			owner="THIS FADER";
			break;
		case sstat.full_control_no_bf:
			status="FULL CONTROL NO BF";
			owner="THIS FADER";
			break;
		case sstat.locked_elsewhere:
			status="LISTEN ONLY";
			owner=this.src_owner;
			if(this.src_fader>0) owner=(this.src_fader+": ")+owner;
			break;
		case sstat.listenonly_lock_err:
			status="LISTEN ONLY (LOCK ERROR)";
			owner=this.src_owner;
			if(this.src_fader>0) owner=(this.src_fader+": ")+owner;
			break;
		}
		if(status==null)
		{
			this.stat.hide();
			this.owner.hide();
		}
		else
		{
			this.stat.setText(status);
			this.stat.show();
			this.owner.setText("Owner: "+owner);
			this.owner.show();
		}
	}
	obj.setSharingInfo=function(status, owner, fader)
	{
		this.src_state=status;
		this.src_owner=owner;
		this.src_fader=fader;
		this.updateSharingInfo();
	}

	return obj;
}
function choptCreateFeed(frm)
{
	var obj={id:'chm1'};
	obj.frame=gui.newFrame(frm, 231, 80, 152, 77, "img/chopt_feed.png");
	obj.name =gui.newLabel  (obj.frame, 10, 27, 110, 19, '', prop_src);
	obj.auto =gui.newPicture(obj.frame, 15, 49,  35, 8, "img/led_auto.png");
	GUI_createSmallMeter(obj.frame, 122, 23, mtrGUI.chopt_feed);

	obj.focus=function(on)
	{
		var bg=on?"img/chopt_feed_sel.png":"img/chopt_feed.png";
		var idx=on?1:0;

		this.frame.setBg(bg);
		this.auto.setIndex(-1, idx);
	}
	obj.indi=function(msg)
	{
		if('bSRCT' in msg)
		{
			if(msg.bSRCT==srct.codec || msg.bSRCT==srct.phone)
			{
				this.name.show();
				this.auto.show();
			}
			else
			{
				this.name.hide();
				this.auto.hide();
			}
		}
		if('bSDSP' in msg) this.name.setText((msg.bSDSP in sdsp_txt)?sdsp_txt[msg.bSDSP]:"");
		if('bFSMO' in msg) this.auto.setIndex(msg.bFSMO==4?1:0);
	}

	return obj;
}
function choptCreateEq(frm)
{
	var obj={id:'cheq'};
	obj.frame=gui.newFrame(frm, 66, 165, 317, 111, "img/chopt_eq.png");
	obj.graph=gui.newEq(obj.frame, 25, 12, 243, 77, '');
	eqSetLogFreq(obj.graph, 1, 241, 57, 80);
	obj.graph.setdB(1, 76, 25, 24/15);
	obj.values={lf:0, mf:0, hf:0, lg:0, mg:0, hg:0, lm:false, hm:false, ac:false};

	obj.focus=function(on)
	{
		var bg=on?"img/chopt_eq_sel.png":"img/chopt_eq.png";

		this.frame.setBg(bg);
	}
	obj.indi=function(msg)
	{
		var upd=false;
		var p=this.values;

		if('wEQLF' in msg) {upd=true; p.lf=msg.wEQLF;}
		if('wEQMF' in msg) {upd=true; p.mf=msg.wEQMF;}
		if('wEQHF' in msg) {upd=true; p.hf=msg.wEQHF;}
		if('wEQLG' in msg) {upd=true; p.lg=msg.wEQLG/10;}
		if('wEQMG' in msg) {upd=true; p.mg=msg.wEQMG/10;}
		if('wEQHG' in msg) {upd=true; p.hg=msg.wEQHG/10;}
		if('bEQLM' in msg) {upd=true; p.lm=(msg.bEQLM==1);}
		if('bEQHM' in msg) {upd=true; p.hm=(msg.bEQHM==1);}
		if('bEQAC' in msg) {upd=true; p.ac=(msg.bEQAC==1);}
		if(upd)
		{
			if(p.ac)
				this.graph.setParams(p.lf, p.mf, p.hf, p.lg, p.mg, p.hg, p.lm, p.hm);
			else
				this.graph.setParams(0, 0, 0, 0, 0, 0, false, false);
		}
	}

	return obj;
}
function choptCreatePan(frm)
{
	var obj={id:'chpan'};
	obj.frame=gui.newFrame(frm, 67, 285, 153, 111, "img/chopt_pan.png");
	obj.ctpan=gui.newPan(obj.frame, 27, 23, 93, 58, '');
	obj.ctpan.setParams(48, 52, "img/pan_ball.png");
	obj.radius=37;
	obj.adelta=180/25;
	obj.mode =gui.newLabel(obj.frame, 10, 82, 50, 26, '', prop_value);
	obj.phase=gui.newLabel(obj.frame, 88, 82, 50, 26, '', prop_value);
// FIXME: when stereo pan @ -90 or 90 half of a ball is cut
	obj.values={src_stereo: false, mode: mode_type.stereo, pan: [0,0], phase: 1};

	obj.focus=function(on)
	{
		var bg=on?"img/chopt_pan_sel.png":"img/chopt_pan.png";
		var prop=on?propOn:propOff;

		this.frame.setBg(bg);
		this.mode .setProps(prop);
		this.phase.setProps(prop);
	}
	obj.indi=function(msg)
	{
		var upd=false;
		var p=this.values;

		if( 'bSRCT' in msg) {p.src_stereo=srcIsStereo(msg.bSRCT); upd=true;}
		if( 'bMODE' in msg) {p.mode =msg.bMODE; upd=true;}
		if( 'bPHAS' in msg) {p.phase=msg.bPHAS; upd=true;}
		if('wvPANO' in msg) {p.pan[0]=msg.wvPANO[0]; p.pan[1]=msg.wvPANO[1]; upd=true;}
		if(upd)
		{
			var idx=panGetIdx(p.pan[0], p.pan[1]);
			var angle=-90+idx/pan_const.val_table_maxind*180;
			var t;

			t=p.src_stereo?phase_txt_stereo:phase_txt_mono;
			this.phase.setText(((p.phase in t)?t[p.phase]:"")+"\nPHASE");
			this.mode.setText(((p.mode in mode_txt)?mode_txt[p.mode]:"")+"\nMODE");
			if(p.src_stereo && p.mode==mode_type.stereo)
				this.ctpan.setValues(this.radius, this.radius, angle-this.adelta, angle+this.adelta);
			else
				this.ctpan.setValues(this.radius, -1, angle, 0);
		}
	}

	return obj;
}
function choptCreateCodec(frm)
{
	var obj={id:'chcodec'};
	obj.frame=gui.newFrame(frm, 231, 284, 153, 112, "img/chopt_codec.png");
// TODO: actual codec details
// TODO: Lock image

	obj.focus=function(on)
	{
		var bg=on?"img/chopt_codec_sel.png":"img/chopt_codec.png";

		this.frame.setBg(bg);
	}
	obj.indi=function(msg)
	{
	}

	return obj;
}
function choptCreateMicproc(frm)
{
	var obj={id:'chmicproc'};
	obj.frame=gui.newFrame(frm, 231, 284, 153, 111, "img/chopt_micproc.png");
	obj.mtrexp =gui.newMeter(obj.frame,  25, 34, 15, 60, "img/mtr_dyn.png");
	obj.mtrcomp=gui.newMeter(obj.frame,  63, 34, 15, 60, "img/mtr_dyn.png");
	obj.mtrdess=gui.newMeter(obj.frame, 101, 34, 15, 60, "img/mtr_dyn.png");
	obj.mtrfrze=gui.newMeter(obj.frame,  65, 21, 11, 11, "img/mtr_freeze.png");
	obj.mtrexp .setBars(30); obj.mtrexp .setPoints([-300, 30, 0, 0]); obj.mtrexp .setDir(1);
	obj.mtrcomp.setBars(30); obj.mtrcomp.setPoints([-300, 30, 0, 0]); obj.mtrcomp.setDir(1);
	obj.mtrdess.setBars(20); obj.mtrdess.setPoints([-200, 20, 0, 0]); obj.mtrdess.setDir(1);
	obj.mtrfrze.setBars( 1); obj.mtrfrze.setPoints([0, 0, 1, 1]);
	gui.createMeter(mtrGUI.chopt_mic, 6, null, [obj.mtrexp, obj.mtrcomp, obj.mtrdess, obj.mtrfrze]);

	obj.focus=function(on)
	{
		var bg=on?"img/chopt_micproc_sel.png":"img/chopt_micproc.png";

		this.frame.setBg(bg);
	}
	obj.indi=function(msg)
	{
	}

	return obj;
}
function choptCreateSends(frm)
{
	const snd_x=[12,84,176,248];
	var obj={id:'chaux'}, n;
	obj.frame=gui.newFrame(frm, 67, 404, 317, 67, "img/chopt_sends.png");
	obj.s=[];
	for(n=0; n<4; n++)
	{
		obj.s[n]=
		{
			onoff: gui.newPicture(obj.frame, snd_x[n]+ 0, 31, 17, 17, "img/led_onoff.png"),
			val:   gui.newLabel  (obj.frame, snd_x[n]+12, 15, 35, 14, '', prop_value),
			mode:  gui.newLabel  (obj.frame, snd_x[n]+40, 36, 25, 14, '', prop_value_left),
			knob:  gui.newKnob   (obj.frame, snd_x[n]+19, 32, 18, 18, "img/knob_18px.png")
		}
	}

	obj.focus=function(on)
	{
		var bg=on?"img/chopt_sends_sel.png":"img/chopt_sends.png";
		var prop=on?propOn:propOff;
		var idx=on?1:0;
		var n;

		this.frame.setBg(bg);
		for(n=0; n<4; n++)
		{
			this.s[n].onoff.setIndex(-1, idx);
			this.s[n].val.setProps(prop);
			this.s[n].mode.setProps(prop);
			this.s[n].knob.setIndex(idx);
		}
	}
	obj.indi=function(msg)
	{
		if('bAUX1' in msg) this.s[0].onoff.setIndex(msg.bAUX1==1?1:0);
		if('bAUX2' in msg) this.s[1].onoff.setIndex(msg.bAUX2==1?1:0);
		if('bAUX3' in msg) this.s[2].onoff.setIndex(msg.bAUX3==1?1:0);
		if('bAUX4' in msg) this.s[3].onoff.setIndex(msg.bAUX4==1?1:0);
		if('bA1PF' in msg) this.s[0].mode.setText(msg.bA1PF==1?"POST":"PRE");
		if('bA2PF' in msg) this.s[1].mode.setText(msg.bA2PF==1?"POST":"PRE");
		if('bA3PF' in msg) this.s[2].mode.setText(msg.bA3PF==1?"POST":"PRE");
		if('bA4PF' in msg) this.s[3].mode.setText(msg.bA4PF==1?"POST":"PRE");
		if('wA1GN' in msg) knobSetValue(this.s[0], msg.wA1GN, aux_const);
		if('wA2GN' in msg) knobSetValue(this.s[1], msg.wA2GN, aux_const);
		if('wA3GN' in msg) knobSetValue(this.s[2], msg.wA3GN, aux_const);
		if('wA4GN' in msg) knobSetValue(this.s[3], msg.wA4GN, aux_const);
	}

	return obj;
}

/*
** choptNavigate
**
** navigate channel options
*/
function choptNavigate(d)
{
	var nf=this.focus;

	if(nf<0)
	{
		nf=-1;
		d=1;
	}

	if(d<0)
		while(nf-->0)
	{
		if(this.focuslist[nf]!=null) break;
	}
	else
		while(nf++<(this.focuslist.length-1))
	{
		if(this.focuslist[nf]!=null) break;
	}

	if((nf in this.focuslist) && this.focuslist[nf]!=null) this.setFocus(nf);
}

function choptKnobSetup()
{
	var chn=ch_data[this.channel];
	var prop={enabled:false, rot:null};

	switch(chn.knob_fn)
	{
	case knobFn.fatg:
		prop={enabled: (chn.gain_lock==1), rot:host.sprintf("Trim Level\n%+.1f dB", chn.gain/10)};
		break;
	case knobFn.gain:
		if(chn.src_lwrp)
			prop={enabled:true, rot:host.sprintf("PreAmp Lvl\n%+.1f dB", chn.src_gain/10), angleNrm: (chn.src_gain+200)/1050};
		break;
	case knobFn.pano:
		return;
	case knobFn.auxA:
		break;
	case knobFn.auxB:
		break;
	case knobFn.auxC:
		break;
	case knobFn.auxD:
		break;
	}
	sknobsSetOne(1, prop);
	sknobsSetOne(7, prop);
}

function choptKnobRot(delta)
{
	var chn=ch_data[this.channel];

	switch(chn.knob_fn)
	{
	case knobFn.fatg:
		//if(!chn.gain_lock)
			host.sendChnCmsg(this.channel, {id:"WRIN", wFATG: valAdjust(chn.gain, delta, {min: -250, max: 250, step: 5, units: "dB"})});
		break;
	case knobFn.gain:
		if(chn.src_lwrp)
			host.lwctrlSetGain(chn.lpid, valAdjust(chn.src_gain, delta, {min: -200, max: 850, step: 5, units: "dB"}));
		break;
	}
}

function choptKnobGain(gain)
{
	var chn=ch_data[this.channel];
	var prop;

	if(chn.knob_fn==knobFn.gain && chn.src_lwrp)
	{
		prop={enabled:true, rot:host.sprintf("PreAmp Lvl\n%+.1f dB", gain/10), angleNrm: (gain+200)/1050};
		sknobsSetOne(1, prop);
		sknobsSetOne(7, prop);
	}
}

function choptPageCreate()
{
	var p={id:"chopt"};
	var f;

// ch.options container frame
	p.frame=gui.newFrame(mainframe, 0, 0, 463, 507, '');
	p.frame.hide();
	f=p.frame;

	gui.newFrame(f, 201, 51, 145, 12, "img/channel_options.png");
	p.title={};
	p.title.frame=gui.newFrame(f, 93, 45, 100, 26, "img/chopt_title.png");
	p.title.label=gui.newLabel(p.title.frame, 5, 6, 90, 15, '', prop_channel);

// 1. Current Source
	p.source=choptCreateSource(f);
// 2. Feed to Source (only for Codec & Phone)
	p.feed=choptCreateFeed(f);
// 3. Eq
	p.eq=choptCreateEq(f);
// 4. Pan & Mode
	p.pan=choptCreatePan(f);
// 5.a Codec Details (only for Codec, disabled for now)
	p.codec=choptCreateCodec(f);
// 5.b Dynamics aka MicProcessing (only for Mics, Phone and Codec)
	p.micproc=choptCreateMicproc(f);
// 6. Aux Sends
	p.sends=choptCreateSends(f);

	p.focuslist=
	[
		p.source, p.feed,
		p.eq,
		p.pan,    p.micproc,
		p.sends
	];
	p.focus=-1;
	p.setFocus=function(newfocus)
	{
		if(newfocus==this.focus) return;
	// remove focus
		if(this.focus in this.focuslist) this.focuslist[this.focus].focus(false);
		this.focus=newfocus;
		if(this.focus in this.focuslist) this.focuslist[this.focus].focus(true);
	}
	p.navigate=choptNavigate;

// softknobs
	p.sknobs6=
	[
		{enabled: true, rot: "FUNCTION", push: "SELECT", jog: true, ltrt:true, enter: true},
		{enabled: false},
		{enabled: false},
		{enabled: false},
		{enabled: false},
		{enabled: false}
	];
	p.sknobs3=
	[
		{enabled: true, rot: "FUNCTION", push: "SELECT", jog: true, ltrt:true, enter: true},
		{enabled: false},
		{enabled: true, push: "EXIT"}
	];

// event functions
	p.onOpen        =choptOnOpen;
	p.onClose       =choptOnClose;
	p.onIndi        =choptIndi;
	p.onSoftKnobRot =choptOnSoftKnobRot;
	p.onSoftKnobDown=choptOnSoftKnobDown;
	p.onSoftKnobUp  =choptOnSoftKnobUp;

	p.choptKnobSetup=choptKnobSetup;
	p.choptKnobRot  =choptKnobRot;
	p.onGainChange  =choptKnobGain;

	pages.chopt=p;
}

function choptOnOpen(channel_nr)
{
	if(channel_nr==null) return;

	sknobsShow(mod.comboPresent()?this.sknobs3:this.sknobs6);

	this.channel=channel_nr;
	this.title.label.setText(host.sprintf("CHANNEL %02d", this.channel));
	this.choptKnobSetup();

// request information for this channel
	var rmsg=host.sendChnCmsgRq(channel_nr, {id:"READ",
		bSRCN:0, bSRCT:0, bFSMO:0, bSDSP:0, bBFEN:0, // source, m1
		bEQHF:0, bEQMF:0, bEQLF:0, bEQHG:0, bEQMG:0, bEQLG:0, bEQAC:0, bEQHM:0, bEQLM:0, // eq
		bPANO:0, bMODE:0, bPHAS:0, bMLCK:0, // pan
		bA1GN:0, bA2GN:0, bA3GN:0, bA4GN:0,
		bAUX1:0, bAUX2:0, bAUX3:0, bAUX4:0,
		bA1PF:0, bA2PF:0, bA3PF:0, bA4PF:0, // aux
		bFATG:0, bFATL:0 // Fader Trim Gain
	});
	if(rmsg!=null)
	{
		this.onIndi(rmsg);

	// update source sharing info: FIXME: it's a hack we need to read it just like any other parameters
		this.source.setSharingInfo(ch_data[channel_nr].src_status, ch_data[channel_nr].src_owner_name, ch_data[channel_nr].src_owner_fader);

	// request meters
		chnRequestMeter(this.channel, mtrEng.chnSrc , mtrGUI.chopt_src ,  true);
		chnRequestMeter(this.channel, mtrEng.chnFeed, mtrGUI.chopt_feed, true);
		chnRequestMeter(this.channel, mtrEng.chnMic , mtrGUI.chopt_mic , true);

	// register receive msg handlers
		pages.rxHandlersCh[this.channel].chopt=this;
		mod.setChnKeyLed(this.channel, keys.ChnOptions, 255);
	}
}
function choptOnClose()
{
	sknobsHide();
// release meters
	chnRequestMeter(this.channel, mtrEng.chnSrc , mtrGUI.chopt_src , false);
	chnRequestMeter(this.channel, mtrEng.chnFeed, mtrGUI.chopt_feed, false);
	chnRequestMeter(this.channel, mtrEng.chnMic , mtrGUI.chopt_mic , false);
// delete receive msg handlers
	delete pages.rxHandlersCh[this.channel].chopt;
	mod.setChnKeyLed(this.channel, keys.ChnOptions, 0);
}
function choptOnSoftKnobRot(idx, delta)
{
	var angle;

	if(idx==1 || idx==7)
	{
		this.navigate(delta);
		sknobsSetOne(0, {angleNrm: this.focus/(this.focuslist.length-1)});
		sknobsSetOne(6, {angleNrm: this.focus/(this.focuslist.length-1)});
	}
	if(idx==2 || idx==8)
		this.choptKnobRot(delta);
}
function choptOnSoftKnobDown(idx)
{
	if(idx==1 || idx==7)
	{
		if(!(this.focus in this.focuslist)) return;
		var block=this.focuslist[this.focus];
		if(block==null) return;
		if(block.id in pages)
			chSwitchToPage(pages[block.id]);
	}
}
function choptOnSoftKnobUp(idx)
{
	switch(idx)
	{
	case 9: // Combo3
		closePage(this, this.channel);
		break;
	}
}
function choptIndi(chmsg)
{
	if('bSRCT' in chmsg)
	{
		var bfeed=('bBFEN' in chmsg)?chmsg.bBFEN==1:false;

	// Backfeed: for Codec and Phone with backfeed
		if((chmsg.bSRCT==srct.codec || chmsg.bSRCT==srct.phone || chmsg.bSRCT==srct.crguest || chmsg.bSRCT==srct.stguest || chmsg.bSRCT==srct.extmic) && bfeed)
		{
			this.feed.frame.show();
			this.focuslist[1]=this.feed;
		}
		else
		{
			this.feed.frame.hide();
			if(this.focus==1) this.setFocus(-1);
			this.focuslist[1]=null;
		}
	// Codec: for Codec
		if(0) // Reserved for later use: if(chmsg.bSRCT==srct.codec)
		{
			this.micproc.frame.hide();
			this.codec.frame.show();
			if(this.focus==4)
			{
				this.micproc.focus(false);
				this.codec.focus(true);
			}
			this.focuslist[4]=this.codec;
		}
	// Dynamics: for Mics, Phone and Codec
		else if(chmsg.bSRCT==srct.crhost || chmsg.bSRCT==srct.crguest || chmsg.bSRCT==srct.stguest || chmsg.bSRCT==srct.extmic || chmsg.bSRCT==srct.producer || chmsg.bSRCT==srct.phone || chmsg.bSRCT==srct.codec)
		{
			this.codec.frame.hide();
			this.micproc.frame.show();
			if(this.focus==4)
			{
				this.micproc.focus(true);
				this.codec.focus(false);
			}
			this.focuslist[4]=this.micproc;
		}
		else
		{
			this.codec.frame.hide();
			this.micproc.frame.hide();
			if(this.focus==4) this.setFocus(-1);
			this.focuslist[4]=null;
		}
	}

	var prop;
	if('bPRIM' in chmsg)
		this.choptKnobSetup();
	if(ch_data[this.channel].knob_fn==knobFn.fatg)
	{
		if('wFATG' in chmsg)
		{
			prop=
			{
				rot: host.sprintf("Trim Gain\n%+.1f dB", chmsg.wFATG/10),
				angleNrm: (chmsg.wFATG+250)/500
			};

			sknobsSetOne(1, prop);
			sknobsSetOne(7, prop);
		}
		if('bFATL' in chmsg)
		{
			prop=
			{
				enabled: (chmsg.bFATL==1)
			};

			sknobsSetOne(1, prop);
			sknobsSetOne(7, prop);
		}
	}

	this.source.indi(chmsg);
	this.feed.indi(chmsg);
	this.eq.indi(chmsg);
	this.pan.indi(chmsg);
	this.codec.indi(chmsg);
	this.micproc.indi(chmsg);
	this.sends.indi(chmsg);
}
