
// ------------------------ global meters page ------------------------
function metersPageCreate()
{
	var p={id:"meters"};
	var f, fr;

// ch.options container frame
	p.frame=gui.newFrame(mainframe, 0, 0, 463, 507, '');
	p.frame.hide();
	f=p.frame;

	gui.newFrame(f, 150, 60, 144, 12, "img/monitor_options.png");
	p.title={};
	p.title.frame=gui.newFrame(f, 174, 84, 100, 26, "img/chopt_title.png");
	p.title.label=gui.newLabel(p.title.frame, 5, 6, 90, 15, '', prop_channel);
	p.title.label.setText("METERS");

// Rightmost Meter Mode
	fr=gui.newFrame(f, 63, 131, 315, 83, "img/monopt_meter.png");
	p.rtmeter=
	{
		title: gui.newLabel  (fr, 48, 12, 258, 14, '', prop_value_left),
		knob:  gui.newPicture(fr, 21, 45,  18, 18, "img/pknob_18px.png"),
		list:  gui.newList   (fr, 58, 40, 225, 32, '', prop_list)
	};
	p.rtmeter.title.setText("RIGHTMOST METER");
	p.rtmeter.list.setProps({border:1});
	p.rtmeter.list.insert(cfg_surroundMode?"PROGRAM 2":"PROGRAM 4", 1);
	p.rtmeter.list.insert("MONITOR1 / PREVIEW", 2);
	p.rtmeter.list.select(0);

// Meter Peaks
	fr=gui.newFrame(f, 63, 216, 315, 83, "img/monopt_meter.png");
	p.mtrpeaks=
	{
		title: gui.newLabel  (fr, 48, 12, 258, 14, '', prop_value_left),
		knob:  gui.newPicture(fr, 21, 45,  18, 18, "img/pknob_18px.png"),
		list:  gui.newList   (fr, 58, 40, 225, 32, '', prop_list)
	};
	p.mtrpeaks.title.setText("METER PEAKS");
	p.mtrpeaks.list.setProps({border:1});
	p.mtrpeaks.list.insert("SHOW", 1);
	p.mtrpeaks.list.insert("HIDE", 0);
	p.mtrpeaks.list.select(0);

// PGM3 Meter Source
	fr=gui.newFrame(f, 63, 301, 315, 83, "img/monopt_meter.png");
	p.mtrxpgm3=
	{
		title: gui.newLabel  (fr, 48, 12, 258, 14, '', prop_value_left),
		knob:  gui.newPicture(fr, 21, 45,  18, 18, "img/pknob_18px.png"),
		list:  gui.newList   (fr, 58, 32, 225, 46, '', prop_list)
	};
	p.mtrxpgm3.title.setText("PGM3 Meter Source");
	p.mtrxpgm3.list.setProps({border:1, barw: 3});
	p.mtrxpgm3.list.insert("Program 3", 803);
	p.mtrxpgm3.list.insert("Record", 731);
	p.mtrxpgm3.list.insert("Phone", 732);
	p.mtrxpgm3.list.insert("External 1", 861);
	p.mtrxpgm3.list.insert("External 2", 862);
	p.mtrxpgm3.list.select(0);

// Meter Ballistics
	fr=gui.newFrame(f, 63, 386, 315, 83, "img/monopt_meter.png");
	p.mtrbal=
	{
		title: gui.newLabel  (fr, 48, 12, 258, 14, '', prop_value_left),
		knob:  gui.newPicture(fr, 21, 45,  18, 18, "img/pknob_18px.png"),
		list:  gui.newList   (fr, 58, 32, 225, 46, '', prop_list)
	};
	p.mtrbal.title.setText("Meter Ballistics");
	p.mtrbal.list.setProps({border:1, barw: 3});
	p.mtrbal.list.insert("Full Scale VU", 0);
	p.mtrbal.list.insert("BBC Type PPM", 1);
	p.mtrbal.list.insert("DIN Type PPM", 2);
	p.mtrbal.list.insert("EBU Digital", 3);
	p.mtrbal.list.insert("NORDIC Type", 4);
	p.mtrbal.list.select(0);

	p.sknobs6=
	[
		{enabled: true, rot: "MTR MODE", push: "TAKE", list: p.rtmeter.list, updn: true, jog: true, enter: true},
		{enabled: true, rot: "MTR PEAKS", push: "TAKE", list: p.mtrpeaks.list},
		{enabled: true, rot: "PGM3 SRC", push: "TAKE", list: p.mtrxpgm3.list},
		{enabled: true, rot: "METER\nBALLISTICS", push: "TAKE", list: p.mtrbal.list},
		{enabled: false},
		{enabled: true, push: "MORE\nMETERS"}
	];

// event functions
	p.onOpen=function(channel_nr)
	{
		var msg={id:"NEST"}, rmsg;

		sknobsShow(this.sknobs6);

		setListActive(this.mtrpeaks.list, host.cfgGetInteger('meter.showPeaks', 1));
		setListActive(this.mtrbal.list, host.cfgGetInteger('meter.ballistics', 0));
		msg[right_mtr_tag]={id:"READ", bSRSW:0};
		msg.mMTRX={id:"READ", mPGM3:{bNSEL:0}};
		rmsg=host.sendCmsgRq(msg);
		if(rmsg!=null)
		{
			metersIndi(rmsg);

			//register receive msg handlers
			pages.rxHandlersGlobal.metersIndi=metersIndi;
			mod.setMasterKeyLed(keys.MstMetOpt, 255);
		}
	};
	p.onClose=function()
	{
		sknobsHide();
		delete pages.rxHandlersGlobal.metersIndi;
		mod.setMasterKeyLed(keys.MstMetOpt, 0);
	};
	p.onSoftKnobDown=function(idx)
	{
		switch(idx)
		{
		case 1:
			host.sendNestCmsg(right_mtr_tag, {id:"WRIN", bSRSW:this.rtmeter.list.selId});
			break;
		case 2:
			gui.setMeterPeaks(this.mtrpeaks.list.selId);
			setListActive(this.mtrpeaks.list, host.cfgGetInteger('meter.showPeaks', 1));
			break;
		case 3:
			host.sendNestCmsg('mMTRX', {id:"WRIN", mPGM3:{wNSEL:this.mtrxpgm3.list.selId}});
			break;
		case 4:
			changeMeterBallistics(this.mtrbal.list.selId);
			setListActive(this.mtrbal.list, host.cfgGetInteger('meter.ballistics', 0));
			break;
		case 6:
			activatePage(pages.mtrx, null);
			break;
		}
	};

	pages.meters=p;
}

function metersIndi(msg)
{
	var p=pages.meters;
	if((right_mtr_tag in msg) && ('bSRSW' in msg[right_mtr_tag]))
		setListActive(p.rtmeter.list, msg[right_mtr_tag].bSRSW);
	if(('mMTRX' in msg) && ('mPGM3' in msg.mMTRX) && ('wNSEL' in msg.mMTRX.mPGM3))
		setListActive(p.mtrxpgm3.list, msg.mMTRX.mPGM3.wNSEL);
}
