// ------------------------ Extra Meter page ------------------------
function mtrxRequestMeter(eId, eMtrId)
{
	var tag=host.sprintf("mM%03u", eId);
	host.sendNestCmsg(tag, {id:'WRIN', wNSEL: eMtrId, bINDE: (eMtrId==0?0:1)});
}

const engMtrDesc=
{
	731: "Record",
	732: "Phone",

	801: "Program 1",
	802: "Program 2",
	803: "Program 3",
	804: "Program 4",

	811: "AUX Send A",
	812: "AUX Send B",
	813: "AUX Send C",
	814: "AUX Send D",

	821: "AUX Ret 1",
	822: "AUX Ret 2",

	841: "Mon1 Direct",
	842: "Monitor 1",
	843: "Headphones",
	844: "Preview",
	847: "Monintor 2",

	861: "External 1",
	862: "External 2"
};

function mtrxGetDesc(engId)
{
	var channel, chn;
	var mixer, fader;

	if(engId==0) return "";
	if(engId>=1 && engId<=256)
	{
	// fader channels
		channel=((engId-1)>>2)+1;
		if(!(channel in ch_data) || !ch_data[channel].exists) return "";
		chn=ch_data[channel];

		switch((engId-1)&3)
		{
		case 0: return chn.src_name;
		case 1: return "To: "+chn.src_name;
		case 2: return "Dyn: "+chn.src_name;
		}
		return "";
	}
	else if(engId>=1000 && engId<1500)
	{
	// V-Mixer Out
		mixer=Math.floor((engId-1000)/10);
		fader=engId%10;
		if(mixer==0)
		{
			if(fader==0) return "VMix Out";
		}
		else if(mixer<=8)
		{
			if(fader==0) return host.sprintf("VMix%d Out", mixer);
			if(fader>=1 && fader<=5)
				return host.sprintf("VMix%d F%d Out", mixer, fader);
		}
	}
	else if(engId>=1500 && engId<2000)
	{
	// V-Mixer In
		mixer=Math.floor((engId-1500)/10);
		fader=engId%10;
		if(mixer>=1 && mixer<=8)
		{
			if(fader>=1 && fader<=5)
				return host.sprintf("VMix%d F%d In", mixer, fader);
		}
	}
	else if(engId>=2000 && engId<2500)
	{
	// V-Mode input
		fader=engId-2000;
		if(fader>=1 && fader<=8)
			return host.sprintf("VMode%d In", fader);
	}
	else if(engId>=2500 && engId<3000)
	{
	// V-Mode output
		fader=engId-2500;
		if(fader>=1 && fader<=8)
			return host.sprintf("VMode%d Out", fader);
	}
	if(engId in engMtrDesc) return engMtrDesc[engId];
	return host.sprintf("[%d]", engId);
}

function mtrxMeterCreate(frame, x, y, tag, id, engId)
{
	var m={eng:engId, tag:tag};
	m.title=gui.newPicture(frame, x, y+202, 83, 15, "img/meter_title.png");
	m.label=gui.newLabel  (m.title, 4, 0, 76, 14, '', prop_value);
	m.input=0;
	m.title="";
	GUI_createMediumMeter (frame, x+7, y, id, engId);
	return m;
}

function mtrxPageCreate()
{
	var p={id:"mtrx"};
	var n;

	p.frame=gui.newFrame(mainframe, 0, 0, 463, 507, '');
	p.frame.hide();

	p.meters=[];
	p.meters[0]=mtrxMeterCreate(p.frame,  63,  38, 'mEXT1', mtrGUI.ext1, 885);
	p.meters[1]=mtrxMeterCreate(p.frame, 183,  38, 'mEXT2', mtrGUI.ext2, 886);
	p.meters[2]=mtrxMeterCreate(p.frame, 303,  38, 'mEXT3', mtrGUI.ext3, 887);
	p.meters[3]=mtrxMeterCreate(p.frame,  63, 265, 'mEXT4', mtrGUI.ext4, 888);
	p.meters[4]=mtrxMeterCreate(p.frame, 183, 265, 'mEXT5', mtrGUI.ext5, 889);
	p.meters[5]=mtrxMeterCreate(p.frame, 303, 265, 'mEXT6', mtrGUI.ext6, 890);

// event functions
	p.onOpen=function(channel_nr)
	{
		var msg={bNSEL:0,bLABL:0};
	// register receive msg handlers
		pages.rxHandlersGlobal.mtrxIndi=mtrxIndi;
		var rmsg=host.sendNestCmsgRq('mMTRX', {id:'READ', mEXT1:msg, mEXT2:msg, mEXT3:msg, mEXT4:msg, mEXT5:msg, mEXT6:msg});
		if(rmsg) this.onIndi(rmsg);
	};
	p.onClose=function()
	{
		var i, m;

		delete pages.rxHandlersGlobal.mtrxIndi;
		for(i in this.meters)
		{
			m=this.meters[i];
			m.input=0;
			m.title="";
			mtrxRequestMeter(m.eng, m.input);
			m.label.setText(m.title);
		}
	};
	p.onIndi=function(msgMtrx)
	{
		var i, m, extmsg, label;

		for(i in this.meters)
		{
			m=this.meters[i];
			if(m.tag in msgMtrx)
			{
				extmsg=msgMtrx[m.tag];

				if('sLABL' in extmsg)
					m.title=extmsg.sLABL;
				if('wNSEL' in extmsg)
				{
					m.input=extmsg.wNSEL;
					mtrxRequestMeter(m.eng, m.input);
				}
				m.label.setText(m.title!=""?m.title:mtrxGetDesc(m.input));
			}
		}
	};

	pages.mtrx=p;
}

function mtrxIndi(msg)
{
	if('mMTRX' in msg) pages.mtrx.onIndi(msg.mMTRX);
}
