
function widget_select(srv, name, values, selected, td, width)
{
	var flag_selected=false;
	var n;

	if(td) srv.putstr("<td>");
	srv.putstr("<select name='"+name+"' style='width:"+width+"px;'>");
	for(n=0; n<values.length; n++)
	{
		srv.putstr("<option value='"+values[n].value+"'");
		if(values[n].value==selected)
		{
			srv.putstr(" selected");
			flag_selected=true;
		}
		srv.putstr(">"+values[n].text+"</option>");
	}
	if(!flag_selected) srv.putstr("<option value='"+selected+"' selected>--- not found ---</option>");
	srv.putstr("</select>");
	if(td) srv.putstr("</td>");
}

function widget_radio(srv, name, values, checked, td)
{
	var n;

	if(values==null) values=[{value: 0, text: "Off"}, {value: 1, text: "On"}];

	if(td) srv.putstr("<td>");
	for(n=0; n<values.length; n++)
	{
		srv.putstr("<input type='radio' name='"+name+"' value='"+values[n].value+"'");
		if(checked==values[n].value) srv.putstr(" checked");
		srv.putstr(">"+values[n].text);
	}
	if(td) srv.putstr("</td>");
}

function widget_input(srv, name, value, size, td)
{
	if(td) srv.putstr("<td>");
	srv.putstr("<input type='text' name='"+name+"' value='"+value+"' size='"+size+"'>");
	if(td) srv.putstr("</td>");
}

function i_to_f(value)
{
	var r = Math.round(value*10)/100
	if (Math.ceil(Math.abs(value/10))*10 == Math.abs(value))
		r = r+'.0';
	return r;
}

function dasm_IP(ip)
{
	return String(ip&0xFF) +"."+ String((ip>> 8)&0xFF) +"."+ String((ip>>16)&0xFF) +"."+ String((ip>>24)&0xFF);
}

function asm_IP(ip)
{
	return ip[0]|(ip[1]<<8)|(ip[2]<<16)|(ip[3]<<24);
}


function checkIP(ipaddr) {
   var re = /^\d{1,3}\.\d{1,3}\.\d{1,3}\.\d{1,3}$/;
   if (re.test(ipaddr)) {
      var parts = ipaddr.split(".");
      for (var i=0; i<parts.length; i++) {
         if (parseInt(parseFloat(parts[i])) > 255) { return false; }
      }
      return parts;
   } else {
      return false;
   }
}

function vmixer_request(srv)
{
	var src_values=[];
	var rmsg;

	srv.putstr("<h2>V-Mixer Settings</h2>");

	rmsg=getSourceList(src_list_mask.vmix, true);
	if(rmsg==null || !('wSRLC' in rmsg))
	{
		print_error_msg(srv, "Unable to get source list");
		return;
	}

	src_values.push({value:-1, text:"--- no source ---"});
	if('mSRLE' in rmsg)
	{
		var n, tag, src;

		for(n=1; n<=rmsg.wSRLC; n++)
		{
			tag=host.sprintf("m%04d", n);
			if(!(tag in rmsg.mSRLE)) continue;

			src=rmsg.mSRLE[tag];
			if(!('dSRCI' in src) || !('sSRCN' in src)) continue;

			src_values.push({value:src.dSRCI, text:src.sSRCN});
		}
	}
	vmixer_print_page(srv, src_values);
}

function vmixer_startup()
{
	var msg_vm={id:'NEST'}, msg_mixer;
	var vmixerVM, vmixerIN;
	var i, j;

	if(vmixer_loaded>0) return;
	vmixer_loaded=2; // loading

	for(i=1; i<=8; i++)
	{
		vmixerVM=vmixer["VM0"+i];

		msg_mixer={id:'NEST', dLPID: vmixerVM.LPID, wMSGN: vmixerVM.MSGN};
		for(j=1; j<=5; j++)
		{
			vmixerIN=vmixerVM["IN0"+j];
			msg_mixer["mIN0"+j]={id:'WRIN', dSRCI: vmixerIN.SRCI, wFAGN: vmixerIN.FAGN, bRAMP: vmixerIN.RAMP, wTMUP: vmixerIN.TMUP, wTMDN: vmixerIN.TMDN};
		}
		msg_vm["mVM0"+i]=msg_mixer;
	}
/* send and wait for response, while ACL handles message */
	host.sendNestCmsgRq('mVMIX', msg_vm);
	vmixer_loaded=1; // loaded
}

function vmixer_process_msg(p_msg)
{
	var i, j, rmsg;
	var msgVM, msgIN;
	var vmixerVM, vmixerIN;

	for(i=1; i<=8; i++)
	{
		if(!(("mVM0"+i) in p_msg)) continue;
		msgVM=p_msg["mVM0"+i];
		vmixerVM=vmixer["VM0"+i];

		if('dLPID' in msgVM)
		{
			vmixerVM.LPID=msgVM.dLPID;
			host.cfgSetInteger("VMIX.VM0"+i+".LPID", vmixerVM.LPID);
		}
		if('wMSGN' in msgVM)
		{
			vmixerVM.MSGN=msgVM.wMSGN;
			host.sendLwMsg(LWCP_sidBroadCast, hObj_VMIX_SUB, [0,i], "EVENT", "Master_Gain="+vmixerVM.MSGN);
			host.cfgSetInteger("VMIX.VM0"+i+".MSGN", vmixerVM.MSGN);
		}
		for(j=1; j<=5; j++)
		{
			if(!(("mIN0"+j) in msgVM)) continue;
			msgIN=msgVM["mIN0"+j];
			vmixerIN=vmixerVM["IN0"+j];
			rmsg={};

			if('bRAMP' in msgIN)
			{
				vmixerIN.RAMP=msgIN.bRAMP;
				rmsg.State=vmixerIN.RAMP?'ON':'OFF';
				host.cfgSetInteger("VMIX.VM0"+i+".IN0"+j+".RAMP", vmixerIN.RAMP);
			}
			if('dSRCI' in msgIN)
			{
				vmixerIN.SRCI=msgIN.dSRCI;
				host.cfgSetInteger("VMIX.VM0"+i+".IN0"+j+".SRCI", vmixerIN.SRCI);
			}
			if('wFAGN' in msgIN)
			{
				vmixerIN.FAGN=msgIN.wFAGN;
				rmsg.Gain=vmixerIN.FAGN;
				host.cfgSetInteger("VMIX.VM0"+i+".IN0"+j+".FAGN", vmixerIN.FAGN);
			}
			if('wTMUP' in msgIN)
			{
				vmixerIN.TMUP=msgIN.wTMUP;
				rmsg.TimeUp=vmixerIN.TMUP;
				host.cfgSetInteger("VMIX.VM0"+i+".IN0"+j+".TMUP", vmixerIN.TMUP);
			}
			if('wTMDN' in msgIN)
			{
				vmixerIN.TMDN=msgIN.wTMDN;
				rmsg.TimeDown=vmixerIN.TMDN;
				host.cfgSetInteger("VMIX.VM0"+i+".IN0"+j+".TMDN", vmixerIN.TMDN);
			}

			host.sendLwMsg(LWCP_sidBroadCast, hObj_VMIX_SUB_IN, [0,i,j], "EVENT", lwcpEncodeProps(rmsg));
		}
	}
}

function vmixer_print_page(srv, src_values)
{
	srv.putstr("<form method='post' action='/usr/vmixer_apply'><table>");

	var ramp_values = [{value : "0", text: "Off"}, {value : "1", text: "On"}];
	var name = "";
	var i = 0, j = 0;
	for( i = 1; i <= 8; i++){

		srv.putstr("<tr class='lhead'><td colspan=2>Mixer " + i + " settings</td></tr><tr> ");

		srv.putstr("<td valign=top>Logic port ID:</td>");
		widget_input(srv, "logic_port_id_"+i, vmixer["VM0"+i].LPID, 10, true);

		srv.putstr("</tr> <tr>");

		srv.putstr("<td valign=top>Master gain (\"volume\") (-80 .. +10dB):</td>");
		widget_input(srv, "master_gain_"+i, i_to_f(vmixer["VM0"+i].MSGN), 10, true);

		srv.putstr("</tr> <tr> <td colspan=2>");
		srv.putstr("<table border='0' cellspacing='0' cellpadding='2' bgcolor='#EEEEEE' id='faders_"+i+"'><tr>");
		srv.putstr("<td>&nbsp;</td><td>&nbsp;</td> <td>Source ID</td> <td>Fader gain<br>(-80 .. +10dB)</td>  <td>Up time<br>(0.0 .. 60.0 sec)</td> <td>Down time<br>(0.0 .. 60.0 sec)</td></tr>");

		for(j=1; j<=5; j++)
		{
			name=(i-1)*5+j;
			srv.putstr("<tr><td>Fader "+j+"</td>");

			widget_radio(srv, "ramp_switch_"+name, ramp_values, vmixer["VM0"+i]["IN0"+j].RAMP, true);
			widget_select(srv, "src_id_"+name, src_values, vmixer["VM0"+i]["IN0"+j].SRCI, true, 150);
			widget_input(srv, "fader_gain_"+name, i_to_f(vmixer["VM0"+i]["IN0"+j].FAGN), 10, true);
			widget_input(srv, "up_time_"+name, i_to_f(vmixer["VM0"+i]["IN0"+j].TMUP), 10, true);
			widget_input(srv, "down_time_"+name, i_to_f(vmixer["VM0"+i]["IN0"+j].TMDN), 10, true);
			srv.putstr("</tr>\n");
		}

		srv.putstr("<tr><td colspan=6><center><input type='submit' name='save_changes' value='Apply'></center></td></tr>");
		srv.putstr("</table>");
		srv.putstr("</td></tr>");
	}

	srv.putstr("</table></form> ");
	srv.finalize();
}

function vmixer_request_apply(srv)
{
	var vm_msg = [];
	var fader_msg = [];
	var mixer_msg = [];
	var msgn, lpid, srci, fagn, ramp, tmup, tmdn;
	var fader_changed = false, mixer_changed = false, vmixer_changed = false;

	if(srv.findVar("save_changes")!=null)
	{
		var name = "";
		var i = 0, j = 0;
		vm_msg = {id:"NEST"};

		for( i = 1; i <= 8; i++){
			mixer_msg = {id:"NEST"};
			mixer_changed = false;

			for( j = 1; j <= 5; j++){
				name = (i-1)*5+j;

				srci = Math.round(srv.findVar("src_id_" + name));
				fagn = inLimit( Math.round(srv.findVar("fader_gain_" + name)*10), -800, 100);
				ramp = inLimit( Math.round(srv.findVar("ramp_switch_" + name)), 0, 1);
				tmup = inLimit( Math.round(srv.findVar("up_time_" + name) *10), 0, 600);
				tmdn = inLimit( Math.round(srv.findVar("down_time_" + name)*10), 0, 600);

				fader_msg = {id:"WRIN"};
				fader_changed = false;

				if (srci != vmixer["VM0"+i]["IN0"+j]["SRCI"]){
					fader_msg["dSRCI"] = srci;
					fader_changed = true;
				}
				if (fagn != vmixer["VM0"+i]["IN0"+j]["FAGN"]){
					fader_msg["wFAGN"] = fagn;
					fader_changed = true;
				}
				if (ramp != vmixer["VM0"+i]["IN0"+j]["RAMP"]){
					fader_msg["bRAMP"] = ramp;
					fader_changed = true;
				}
				if (tmup != vmixer["VM0"+i]["IN0"+j]["TMUP"]){
					fader_msg["wTMUP"] = tmup;
					fader_changed = true;
				}
				if (tmdn != vmixer["VM0"+i]["IN0"+j]["TMDN"]){
					fader_msg["wTMDN"] = tmdn;
					fader_changed = true;
				}
				if (fader_changed){
					mixer_msg["mIN0"+j] = fader_msg;
					mixer_changed = true;
				}
			}
			lpid = inLimit( Math.round(srv.findVar("logic_port_id_" + i)), 0, 32767);
			if (lpid != vmixer["VM0"+i]["LPID"]){
				mixer_msg["dLPID"] = lpid;
				mixer_changed = true;
			}
			msgn = inLimit( Math.round(srv.findVar("master_gain_" + i)*10), -800, 100);
			if (msgn != vmixer["VM0"+i]["MSGN"]){
				mixer_msg["wMSGN"] = msgn;
				mixer_changed = true;
			}
			if (mixer_changed){
				vm_msg["mVM0"+i] = mixer_msg;
				vmixer_changed = true;
			}
		}
		if(vmixer_changed)
			host.sendNestCmsgRq('mVMIX', vm_msg);
	}

	srv.redirect("/usr/vmixer");
	srv.finalize();
}

host.httpRegister("vmixer", 'vmixer_request', true, true);
host.httpRegister("vmixer_apply", 'vmixer_request_apply', false, true);
host.httpAddLink("/usr/vmixer", "Misc.", "V-Mixer", 1000);




///////////////////////////////////////////////////////////////////////////////


function ntp_request(srv)
{
	var rmsg = host.sendNestCmsgRq('mCONF', {id:"READ", bNTPA:0, bNTPB:0, bNTPN:0, bNTPO:0, bNTPT:0});
	srv.putstr("<h2>NTP Settings</h2>");

	if(rmsg!=null && ('dNTPA' in rmsg) && ('dNTPB' in rmsg) && ('bNTPN' in rmsg) && ('bNTPO' in rmsg) && ('wNTPT' in rmsg))
	{
		srv.putstr("<form method='post' action='/usr/ntp_apply'><table>");
		srv.putstr("<tr> <td>NTP On/Off:</td>");
		widget_radio(srv, "ntp_use", null, rmsg.bNTPO,  true);
		srv.putstr("</tr> <tr> <td>NTP server address (primary):</td> <td>");
		widget_input(srv, "ntp_ip_a", dasm_IP(rmsg.dNTPA), 16, false);
		srv.putstr(rmsg.bNTPN==1 ? " <span style='color:#0AB83F;'>active</span> </td>":"</td>");
		srv.putstr("</tr> <tr> <td>NTP server address (secondary):</td> <td>");
		widget_input(srv, "ntp_ip_b", dasm_IP(rmsg.dNTPB), 16, false);
		srv.putstr(rmsg.bNTPN==2 ? " <span style='color:#0AB83F;'>active</span> </td>":"</td>");

		srv.putstr("</tr> <tr> <td>Time zone GMT +/-:</td>");

		var i, j, cur_h, cur_m, ntp_gmt_h = [], ntp_gmt_m = [];
		if (rmsg.wNTPT > 0)
		{
			cur_h = Math.floor(rmsg.wNTPT/60)*60;
			cur_m = rmsg.wNTPT - Math.floor(rmsg.wNTPT/60)*60;
		}else
		{
			cur_h = Math.ceil(rmsg.wNTPT/60)*60;
			cur_m = Math.abs(rmsg.wNTPT - Math.ceil(rmsg.wNTPT/60)*60);
		}

		j = 0;
		for(i = -12; i <= 14; i++)
		{
			ntp_gmt_h[j] = {text:"GMT "+(i>0?"+":"")+i, value:i*60};
			j++;
		}
		j = 0;
		for(i = 0; i <= 45; i += 15)
		{
			ntp_gmt_m[j] = {text:i, value:i};
			j++;
		}

		srv.putstr("<td>");

		widget_select(srv, "time_zone_shift_h", ntp_gmt_h, cur_h, false, 80);
		widget_select(srv, "time_zone_shift_m", ntp_gmt_m, cur_m, false, 40);

		srv.putstr("</td></tr><tr><td colspan='2'><center><input type='submit' name='ntp_apply' value='Apply'></center></td></tr>");
		srv.putstr("</table></form>");
	}
	else
		srv.putstr("<div class='box_err'>Unable to retrieve NTP settings</div>");

	srv.finalize();
}

function ntp_request_apply(srv)
{
	if(srv.findVar("ntp_apply")=="Apply")
	{
		var msg={id:'WRIN'}, checked_ip;

		checked_ip=checkIP(srv.findVar("ntp_ip_a"));
		if(checked_ip===false)
			log.info("Incorrect primary NTP server address");
		else
			msg.dNTPA=asm_IP(checked_ip);

		checked_ip=checkIP(srv.findVar("ntp_ip_b"));
		if(checked_ip===false)
			log.info("Incorrect secondary NTP server address");
		else
			msg.dNTPB=asm_IP(checked_ip);

		msg.bNTPO=inLimit(Math.round(srv.findVar("ntp_use")), 0, 1);
		msg.wNTPT=inLimit(Math.round(srv.findVar("time_zone_shift_h"))+(Math.round(srv.findVar("time_zone_shift_m")))*(srv.findVar("time_zone_shift_h")>0?1:-1), -720, 840);

		host.sendNestCmsg('mCONF', msg);
	}

	srv.redirect("/usr/ntp");
	srv.finalize();
}
host.httpRegister("ntp", 'ntp_request', true, true);
host.httpRegister("ntp_apply", 'ntp_request_apply', false, true);
host.httpAddLink("/usr/ntp", "Misc.", "NTP", 1001);

function engine_request(srv)
{
	var engine_ip;
	var rmsg;
	var surround;

	if(srv.findVar("msg")=='1') print_error_msg(srv, "Error occurred! New settings could not be saved!");

	srv.putstr("<h2>Engine Settings</h2>");

	rmsg=host.sendNestCmsgRq('mCONF', {id:'READ', bENGA:0});
	if(rmsg==null || !('dENGA' in rmsg))
		srv.putstr("<div class='box_err'>Unable to retrieve Engine settings</div>");
	else
	{
		engine_ip=dasm_IP(rmsg.dENGA);
		surround=host.cfgGetString('scr.surroundMode', 'no')=='yes';
		if(cfg_surroundMode!=surround)
			srv.putstr("<div class='box_inf'>You need to <a href='/reboot'>reboot</a> Element to apply new surround mode settings</div>");

		srv.putstr("<form method='post' action='/usr/engine_apply'><table><tr><td>Engine IP:</td>");
		widget_input(srv, "engine_ip", engine_ip, 16, true);
		srv.putstr("</tr><tr><td>Console Mode:</td><td><select name='surround'>");
		srv.printf("<option value='no' %s>Stereo</option>", surround?"":"selected");
		srv.printf("<option value='yes' %s>Surround</option>", surround?"selected":"");
		srv.putstr("</select></tr><tr><td colspan='2' align=right><input type='submit' name='save_changes' value='Save'></td></tr>");
		srv.putstr("</table></form>");
	}

	srv.finalize();
}

function engine_request_apply(srv)
{
	var checked_ip=checkIP(srv.findVar("engine_ip"));
	if(checked_ip!==false)
		host.sendNestCmsg('mCONF', {id:'WRIN', dENGA:asm_IP(checked_ip)});

	var surround=srv.findVar("surround");
	if(surround!=null)
		host.cfgSetString('scr.surroundMode', (surround=="yes")?'yes':'no');

	srv.redirect("/usr/engine");
	srv.finalize();
}

host.httpRegister("engine", 'engine_request', true, true);
host.httpRegister("engine_apply", 'engine_request_apply', false, true);
host.httpAddLink("/usr/engine", "Misc.", "Engine", 1002);

function print_error_msg(srv, msg)
{
// print err.msg.
	srv.putstr("<span style='color:red;font-weight:bold;'>"+msg+"</span>");
}
